

#!/usr/bin/env python
# coding=utf-8

# Récupération de l'objet 'parapheur' et de la configuration
import Parapheur
# 'os' pour manipulation de fichiers
import os
# 'urllib' pour encodages d'URL
import urllib
# Printer coloré
from Parapheur import pprint

__author__ = 'Lukas Hameury'

"""Variables"""
# Frequence de notification email: quotidien  7 heures
## notifFrequency = dict(mode="daily", frequency="7")
# Frequence de notification email: JAMAIS
notifFrequency = dict(mode="never", mail="")
# ordre des colonnes
columnsOrder = {"c0": "title",
                "c1": "visual",
                "c2": "actionDemandee",
                "c3": "type",
                "c4": "bureauName",
                "c5": "dateLimite",
                "c6": "dateEmission",
                "c7": "banetteName"}
"""Variables"""

# Init REST API client
client = Parapheur.getrestclient()


class InitUsers:
    def __init__(self):
        self.ids = [line.rstrip('\n') for line in open('files/idsUsers.txt', 'a+')]
        self.newIds = []
        self.usersToChange = []
        self.toChange = 0
        self.load()
        self.handleusers()
        self.savetofile()

    def load(self):
        self.usersToChange = client.doget("/parapheur/utilisateurs")
        self.toChange = len(self.usersToChange) - len(self.ids)
        pprint.warning("{0} nouveaux utilisateurs trouvés".format(str(self.toChange)), True)

    def handleusers(self):
        i = 0
        for user in self.usersToChange:
            if user.id not in self.ids:
                client.doput("/parapheur/utilisateurs/" + user.id + "/notifications", notifFrequency)
                client.dodelete("/api/people/" + urllib.quote(user.username) + "/preferences",
                                dict(pf='org.adullact.iparapheur.enabledColumns'))
                client.dopost("/api/people/" + urllib.quote(user.username) + "/preferences",
                              {'org.adullact.iparapheur.enabledColumns': columnsOrder})
                i += 1
                pprint.success("{0}/{1} utilisateurs parametré".format(str(i), str(self.toChange)), False, '\r')
            self.newIds.append(user.id)

    def savetofile(self):
        os.remove('files/idsUsers.txt')
        with open('files/idsUsers.txt', 'w+') as idfile:
            for item in self.newIds:
                idfile.write("%s\n" % item)


if client.islogged:
    InitUsers()

pprint.header("Parametrage terminé")

