#!/usr/bin/env python
# coding=utf-8
"""
 * This file is part of GetDocParapheur.
 *
 * GetDocParapheur is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * GetDocParapheur is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * GetDocParapheur. If not, see http://www.gnu.org/licenses/.
"""
__author__ = 'Lukas Hameury'

# Récupération de l'objet 'parapheur' et de la configuration
# Récupération d'un printer coloré
import time
import Parapheur
from Parapheur import pprint

# Init REST API client
client = Parapheur.getrestclient()

"""Variables"""
# Nombre de mois de conservation des dossiers
carence = 6
typeparaph = "TYPE"
sstypeparaph = "SOUSTYPE"
"""Variables"""

# time.time in seconds from 1970, minus 1month
timestamp = (int(time.time()) - 86400 * 30 * carence) * 1000

if client.islogged:
    # 1 - Trouver les dossiers
    dossiersToDelete = client.doget("/parapheur/dossiers", dict(asAdmin='true',
                                                                type=typeparaph,
                                                                sousType=sstypeparaph))
    pprint.log("{0} dossier(s) trouvé(s)".format(str(len(dossiersToDelete))))
    dossiersToDelete = [dossier for dossier in dossiersToDelete if
                        (dossier.dateEmission < timestamp and dossier.banetteName == 'Dossiers en fin de circuit')]
    pprint.log("{0} dossier(s) à supprimer".format(str(len(dossiersToDelete))))
    # Pour chaque dossier dans le bureau donné
    for dossier in dossiersToDelete:
        # 2 - DELETE par admin !!!
        client.dodelete("/parapheur/dossiers/%s/destroy" % dossier.id)
        # Done
        pprint.success("Dossier supprimée : %s" % dossier.title)
