#!/usr/bin/env python
# coding=utf-8
"""
 * This file is part of GetDocParapheur.
 *
 * GetDocParapheur is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * GetDocParapheur is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * GetDocParapheur. If not, see http://www.gnu.org/licenses/.
"""
__author__ = 'Lukas Hameury'

# Récupération de l'objet 'parapheur' et de la configuration
# Récupération d'un printer coloré
import Parapheur
import time
from Parapheur import pprint

# Init REST API client
client = Parapheur.getrestclient()

carence = 30
typeparaph = "PES"
#soustype = "BJ"

# time.time in seconds from 1970, minus 1month
timestamp = (int(time.time()) - 86400*carence)*1000

# Récupération des tickets d'authentification des deux utilisateurs utilisés
#client.login("ws", "secret")

if client.islogged:
    # 1 - Trouver les dossiers à transmettre (asAdmin)
    #client.runas("admin")
    dossiersToDelete = client.doget("/parapheur/archives",  dict(asc='true', filter='{"and":[{"or":[{"ph:typeMetier":"%s"}]}]}' % typeparaph, page="0", pageSize="100", skipped="0", sort="cm:created"))

    pprint.log("{0} dossier(s) trouvé(s)".format(str(len(dossiersToDelete))))
    # Pour chaque dossier dans le bureau donné
    for dossier in dossiersToDelete:
        # Si le dossier est trop vieux d'un mois
        if timestamp > dossier.created :
            # 2 - DELETE par admin !!!
            # client.runas("admin")
            client.executescript("script/deleteArchive.js", format=(dossier.id,))
            # Done
            pprint.success("Archive supprimée : {0}".format(dossier.title))
